# export PATH="$PATH:/mnt/c/Program Files/Oracle/VirtualBox"
# export VAGRANT_WSL_ENABLE_WINDOWS_ACCESS="1"
# export VAGRANT_WSL_WINDOWS_ACCESS_USER_HOME_PATH="/mnt/c/"
# ln -s /mnt/c/vagrant_project ~/project

# -*- mode: ruby -*-
# vi: set ft=ruby :

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.
Vagrant.configure("2") do |config|
  # config.vm.box = "ubuntu/trusty64"
  # config.vm.boot_timeout = 600
  # config.vm.box = "ubuntu/bionic64"
  config.vm.box = "generic/ubuntu2004"
  ## config.ssh.username = 'vagrant'
  ## config.ssh.password = 'vagrant'
  ## config.ssh.insert_key = "false"
  # config.vm.network :forwarded_port, guest: 22, host: 2522, auto_correct: false, id: "ssh"
  # config.vm.network "forwarded_port", guest: 80, host: 8080
  ## config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"
  ## config.vm.network "public_network"
  # config.vm.network "private_network", ip: "192.168.56.4"
  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  # Every Vagrant development environment requires a box. You can search for
  # boxes at https://vagrantcloud.com/search.

  config.vm.define "machine_test" do |machine|
    machine.vm.hostname = "machine"

    config.vm.provider "virtualbox" do |v|

      disk = './secondHDD12.vdi'
  
      unless File.exist?(disk)
        v.customize ['createhd', '--filename', disk, '--size', 4 * 1024]
        # v.customize [ "createmedium", "disk", "--filename", disk, "--format", "vdi", "--size", 4 * 1024 ]
      end
  
      v.customize ['storageattach', :id, '--storagectl', 'IDE Controller', '--port', 1, '--device', 0, '--type', 'hdd', '--medium', disk]
      # v.customize ['storageattach', :id, '--storagectl', 'IDE Controller', '--port', 1, '--device', 0, '--type', 'hdd', '--medium', File.absolute_path(disk)]
  
      v.customize ["modifyvm", :id, "--cableconnected1", "on"]
  

      # v.gui = true
  
      ## v.customize ['createhd', '--filename', "./baseHDD8.vdi", '--size', 1 * 1024]
      ## v.customize ['storageattach', :id, '--storagectl', 'SATAController', '--port', 0, '--device', 0, '--type', 'hdd', '--medium', "./baseHDD6.vdi"]
      # v.customize ['storageattach', :id, '--storagectl', 'IDE', '--port', 0, '--device', 0, '--type', 'hdd', '--medium', "./baseHDD4.vdi"]
  
      ### v.customize ['createhd', '--filename', "./secondHDD11.vdi", '--size', 2 * 1024]
      # v.customize ['storageattach', :id, '--storagectl', 'SATAController', '--port', 1, '--device', 0, '--type', 'hdd', '--medium', "./secondHDD9.vdi"]
      ### v.customize ['storageattach', :id, '--storagectl', 'IDE', '--port', 1, '--device', 1, '--type', 'hdd', '--medium', "./secondHDD11.vdi"]
  
      v.customize [ "modifyvm", :id, "--uartmode1", "disconnected" ]
      ### v.customize ["modifyvm", :id, "--cableconnected1", "on"]
    end

    # machine.vm.provision 'shell', inline: 'echo "vagrant:vagrant" | chpasswd'

    # machine.ssh.username = 'vagrant'
    # machine.ssh.password = 'vagrant'
    # machine.ssh.insert_key = "true"

    machine.vm.provision "shell", inline: "mkdir /data"
    machine.vm.provision "shell", inline: <<-SHELL
      apt install sshpass
    SHELL

    machine.vm.provision "ansible", run: "always" do |ansible|
      ansible.playbook = "main.yml"
      ansible.extra_vars = {
        ansible_connection: "ssh",
        ansible_user: "vagrant",
        ansible_ssh_pass: "vagrant",
      }
    end
  end

    # puts "harddrive 1"
    # v.customize ['createhd', '--filename', "./disk1.vdi",'--variant', 'Fixed', '--size', 1 * 1024]
    # v.customize ['storageattach', :id,  '--storagectl', 'IDE', '--device', 0, '--type', 'hdd', '--medium', "./disk1.vdi"]  

    # puts "harddrive 2"
    # v.customize ['createhd', '--filename', "./disk2.vdi",'--variant', 'Fixed', '--size', 2 * 1024]
    # v.customize ['storageattach', :id,  '--storagectl', 'IDE', '--device', 1, '--type', 'hdd', '--medium', "./disk2.vdi"]  
    # Drives = [1,2]
    # Drives.each do |hd|
    #       puts "harddrive #{hd}"
    #       v.customize ['createhd', '--filename', "./disk#{hd}.vdi",'--variant', 'Fixed', '--size', 1 * 1024]
    #       v.customize ['storageattach', :id,  '--storagectl', 'IDE', '--device', hd - 1, '--type', 'hdd', '--medium', "./disk#{hd}.vdi"]  
    # end
  # end

  # Disable automatic box update checking. If you disable this, then
  # boxes will only be checked for updates when the user runs
  # `vagrant box outdated`. This is not recommended.
  # config.vm.box_check_update = false

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # NOTE: This will enable public access to the opened port
  # config.vm.network "forwarded_port", guest: 80, host: 8080

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine and only allow access
  # via 127.0.0.1 to disable public access
  # config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"

  # Create a private network, which allows host-only access to the machine
  # using a specific IP.
  # config.vm.network "private_network", ip: "192.168.33.10"

  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.
  # config.vm.network "public_network"

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.
  # config.vm.synced_folder "../data", "/vagrant_data"

  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  # config.vm.provider "virtualbox" do |vb|
  #   # Display the VirtualBox GUI when booting the machine
  #   vb.gui = true
  #
  #   # Customize the amount of memory on the VM:
  #   vb.memory = "1024"
  # end
  #
  # View the documentation for the provider you are using for more
  # information on available options.

  # Enable provisioning with a shell script. Additional provisioners such as
  # Ansible, Chef, Docker, Puppet and Salt are also available. Please see the
  # documentation for more information about their specific syntax and use.
  # config.vm.provision "shell", inline: <<-SHELL
  #   apt-get update
  #   mkfs.ext4 /dev/sdb
  #   mkdir /mnt/storage
  #   mount /dev/sdb /mnt/storage
  # SHELL
end
